Attribute VB_Name = "Sys"
'
'   RunProcess(CommandLine)
'
'       Called from VB6 code to run a program.  Suspends the caller
'       until completion of called process.  Does not
'       redirect that program's output to the caller.
'
'       The sole argument is a string variable which contains
'       the command to execute.

'       This subroutine works by making direct calls to an NT 4.0
'       API, kernel32


'Windows API/Global Declarations
' for :WaitForSingleObject
'**************************************
Public Const NORMAL_PRIORITY_CLASS = &H20&
Public Const INFINITE = -1&
Public Const STARTF_USESHOWWINDOW = 1&
Public Const SW_HIDE = 0&

Public Type STARTUPINFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Long
    cbReserved2 As Long
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
    End Type


Public Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessId As Long
    dwThreadId As Long
    End Type
    'Note: the number of line continuations
    '     in the next declare exceed VBs
    'maximum; they are presented here only f
    '     or clarity.


Public Declare Function CreateProcessA Lib "kernel32" _
    (ByVal lpAppName As Long, _
    ByVal lpCommandLine As String, _
    ByVal lpProcessAttributes As Long, _
    ByVal lpThreadAttributes As Long, _
    ByVal bInheritHandles As Long, _
    ByVal dwCreationFlags As Long, _
    ByVal lpEnvironment As Long, _
    ByVal lpCurrentDirectory As Long, _
    lpStartupInfo As STARTUPINFO, _
    lpProcessInformation As PROCESS_INFORMATION) As Long


'Public Declare Function WaitForSingleObject Lib "kernel32" _
'   (ByVal hHandle As Long,
'    ByVal dwMilliseconds As Long) As Long

Public Declare Function WaitForSingleObject Lib "kernel32" _
    (ByVal hHandle As Long, _
    ByVal dwMilliseconds As Long) As Long


Public Declare Function CloseHandle Lib "kernel32" _
    (ByVal hObject As Long) As Long
    
    


Sub RunProcess(cmdLine As String)

    Dim proc As PROCESS_INFORMATION
    Dim start As STARTUPINFO
    Dim r As Long
   
  'Initialize the STARTUPINFO structure by
  'passing to start the size of the STARTUPINFO
  'type. Setting the  .cb member is the only
  'item of the structure needed to launch the program
   start.cb = Len(start)
   
   'These two lines cause a startup of the spawned app to
   ' be with a hidden window
   start.wShowWindow = SW_HIDE
   start.dwFlags = STARTF_USESHOWWINDOW
   
  'Start the application
   Call CreateProcessA(0&, cmdLine, 0&, 0&, 1&, _
                       NORMAL_PRIORITY_CLASS, 0&, 0&, _
                       start, proc)
   
  'Wait for the application to finish
   Call WaitForSingleObject(proc.hProcess, INFINITE)
   
  'Close the handle to the process
   Call CloseHandle(proc.hProcess)

End Sub
    
    
    
'**************************************
' Name: WaitForSingleObject
' Description:How to start an external p
'     rocess using OpenProcess and pause while
'     the process is active
' By: VB Net (Randy Birch)
'
'
' Inputs:None
'
' Returns:None
'
'Assumes:None
'
'Side Effects:None
'
'Warranty:
'Code provided by Planet Source Code(tm)
'     (http://www.Planet-Source-Code.com) 'as
'     is', without warranties as to performanc
'     e, fitness, merchantability,and any othe
'     r warranty (whether expressed or implied
'     ).
'Terms of Agreement:
'By using this source code, you agree to
'     the following terms...
' 1) You may use this source code in per
'     sonal projects and may compile it into a
'     n .exe/.dll/.ocx and distribute it in bi
'     nary format freely and with no charge.
' 2) You MAY NOT redistribute this sourc
'     e code (for example to a web site) witho
'     ut written permission from the original
'     author.Failure to do so is a violation o
'     f copyright laws.
' 3) You may link to this code from anot
'     her website, provided it is not wrapped
'     in a frame.
' 4) The author of this code may have re
'     tained certain additional copyright righ
'     ts.If so, this is indicated in the autho
'     r's description.
'**************************************

'**************************************


